package  
{
	import flash.display.DisplayObject;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.geom.Rectangle;
	/**
	 * ...
	 * @author Kragnir
	 */
	public class Enemy extends Sprite
	{
		[Embed(source = "../images/enemy1forward.png")]
		private var enemy1Forward:Class;
		
		[Embed(source = "../images/enemy1backwards.png")]
		private var enemy1Backwards:Class;
		
		[Embed(source = "../images/enemy1slashingbackwards.png")]
		private var enemy1SlashingBackwards:Class;
		
		[Embed(source = "../images/slashbackwards.png")]
		private var slashBackwards:Class;
		
		[Embed(source = "../images/enemy1slashingforward.png")]
		private var enemy1SlashingForward:Class;
		
		[Embed(source = "../images/slashforward.png")]
		private var slashForward:Class;
		
		[Embed(source = "../images/magestationary.png")]
		private var mageS:Class;
		
		[Embed(source = "../images/magecasting.png")]
		private var mageC:Class;
		
//		private var AI:Array = [//Nothing, left, right, jump, slash
//		[4,0,0,0,4,0,0,0,3,0,0,0,4,0,0,0,4
		
		//public var
		public var slashes:Vector.<DisplayObject> = new Vector.<DisplayObject>();
		public var e1For:DisplayObject;
		public var e1Back:DisplayObject;
		public var e1ForSlash:DisplayObject;
		public var e1BackSlash:DisplayObject;
		public var m1S:DisplayObject;
		public var m1C:DisplayObject;
		
		
		private var tDisplayer:textdisplayer;
		private var introText:Vector.<Sprite> = new Vector.<Sprite>();
		public var textCounter:int;
		public var textLineCounter:int;
		private var textBox:Shape;
		public var textFinished:Boolean;
		
		public var isDead:Boolean;
		public var hp:int;
		private var hitCooldown:int;
		public var aICounter:int;
		public var type:int;
		private var direction:int;
		private var drawDirection:int;
		public var tempX:Number;
		public var tempY:Number;
		private var tempVX:Number;
		private var tempVY:Number;
		private var tempAY:Number;
		public var offsetX:int;
		public var offsetY:int;
		public var currX:Number;
		public var currY:Number;
		public var collisionWidth:int;
		public var collisionHeight:int;
		public var globalX:int;
		public var globalY:int;
		private var vX:Number;
		private var vY:Number;
		private var aY:Number;
		private var attemptJump:Boolean;
		private var holdJump:Boolean;
		private var isSlashing:Boolean;
		private var haveImage:Boolean;
		private var jumpTimer:int;
		private var slashTimer:int;
		private var canJump:Boolean;
		public var currImage:DisplayObject;
		public var currSlashImage:DisplayObject;
		private var isAPressed:Boolean;
		private var isDPressed:Boolean;
		
		public function getDamageArea():Vector.<Rectangle>
		{
			var tV:Vector.<Rectangle> = new Vector.<Rectangle>();
			for (var i:int = 0; i < slashes.length; i++ )
			{
				tV[tV.length] = new Rectangle(slashes[i].x, slashes[i].y, slashes[i].width, slashes[i].height);
			}
			return tV;
		}
		
		public function checkHit(tV:Vector.<Rectangle>):Boolean
		{
			for (var j:int = 0; j < tV.length; j++)
			{
				var dX:Number = tV[j].x - currX + tV[j].width / 2 - collisionWidth / 2;
				var dY:Number = tV[j].y - currY + tV[j].height / 2 - collisionHeight / 2;
				var RX:Number = tV[j].width / 2 + collisionWidth / 2;
				var RY:Number = tV[j].height / 2 + collisionHeight / 2;
				if (Math.abs(dX) < RX && Math.abs(dY) < RY)
				{
					return true;
				}
			}
			return false;
		}

		public function getHit():Boolean
		{
			if (hitCooldown == 0)
			{
				hitCooldown = 30;
				currImage.alpha = 0.5;
				hp--;
				if (hp == 0)
				{
					isDead = true;
					removeChild(currImage);
					for (var i:int = 0; i < slashes.length; i++ )
					{
						removeChild(slashes[i]);
						if (type == 0)
						{
							introText = new Vector.<Sprite>();
							introText[0] = tDisplayer.getTextSprite("YOU CAN NOW DOUBLEJUMP");
							textLineCounter = 0;
							textCounter = 0;
						}
					}
				}
			}
			return isDead;
		}
		
		public function addText(tString:String):void
		{
			introText[introText.length] = tDisplayer.getTextSprite(tString);
		}
		
		private function progressText():void
		{
			if (introText.length > textLineCounter)
			{
				textCounter++;
				var displayLines:int = 3;
				if (introText.length - textLineCounter < displayLines)
					displayLines = introText.length - textLineCounter;
				if (textCounter >= displayLines*45)
				{
					if (textLineCounter + 3 > introText.length)
						removeChild(textBox);
					for (var i:int = textLineCounter; i < Math.min(introText.length, textLineCounter + 3); i++ )
					{
						removeChild(introText[i]);
					}
					textLineCounter+=3;
					textCounter = 0;
				}
				if (displayLines > 0)
				{
					var maxLength:int = 0;
					for (i = 0; i < introText.length; i++ )
					{
						if (introText[i].width+10 > maxLength)
							maxLength = introText[i].width+10;
					}
					var textBoxLeftEdge:int = Math.max(20, currX - 100);
					var textBoxRightEdge:int = Math.min(640, textBoxLeftEdge + maxLength);
					textBoxLeftEdge = textBoxRightEdge-maxLength;
					if (textLineCounter == 0 && textCounter == 1)
					{
						textBox = new Shape();
						textBox.graphics.beginFill(0);
						textBox.graphics.drawRect(0, 0, maxLength+10, 17 * 3+20);
						textBox.graphics.endFill();
						addChild(textBox);
					}
					textBox.x = textBoxLeftEdge - 15;
					textBox.y = currY-(17*3+25)-10;
					for (i = textLineCounter; i < Math.min(introText.length, textLineCounter + 3); i++ )
					{
						introText[i].x = textBoxLeftEdge;
						introText[i].y = currY - (17*3+25) + (i - textLineCounter) * 17;
						if ((textLineCounter == 0 && textCounter == 1) || textCounter == 0)
						{
							addChild(introText[i]);
						}
					}
				}
			}
			else
				textFinished = true;
		}
		
		private function drawSlash():void
		{
			if (haveImage)
				removeChild(currImage);
			if (type == 0)
			{
				if (direction == 0)
				{
					offsetX = -10;
					offsetY = 0;
					currImage = e1BackSlash;
				}
				else
				{
					offsetX = 0;
					offsetY = 0;
					currImage = e1ForSlash;
				}
			}
			else if (type == 1)
			{
				offsetX = 0;
				offsetY = 0;
				currImage = m1C;
			}
			currImage.scaleX = 2;
			currImage.scaleY = 2;
			if (hitCooldown != 0)
				currImage.alpha = 1 - 0.5 * hitCooldown / 30;
			currImage.x = Math.floor(currX);
			currImage.y = Math.floor(currY);
			addChild(currImage);
			haveImage = true;
		}
			
		private function drawCharacter():void
		{
			if (haveImage)
				removeChild(currImage);
			if (type == 0)
			{
				if (direction == 0)
				{
					offsetX = 0;
					offsetY = 0;
					currImage = e1Back;
				}
				else
				{
					offsetX = 0;
					offsetY = 0;
					currImage = e1For;
				}
			}
			else if (type == 1)
			{
				offsetX = 0;
				offsetY = 0;
				currImage = m1S;
			}
			currImage.scaleX = 2;
			currImage.scaleY = 2;
			currImage.x = Math.floor(currX);
			currImage.y = Math.floor(currY);
			if (hitCooldown != 0)
				currImage.alpha = 1 - 0.5 * hitCooldown / 30;
			addChild(currImage);
			haveImage = true;
		}
		
		public function accelerateY(newAY:Number):void
		{
			aY = newAY;
			if (type == 1)
				aY = 0;
		}
		
		public function testCollision(testDirection:int, dT:Number):void
		{
			tempX = currX;
			tempY = currY;
			tempVY = vY;
			tempAY = aY;
			tempVX = vX;
			if (testDirection & 1)
			{
				if (tempVX > 0)
					tempVX = 0;
			}
			if (testDirection & 4)
			{
				if (tempVX < 0)
					tempVX = 0;
			}
			if (testDirection & 2)
			{
				if (tempVY > 0)
					tempVY = 0;
				if (tempAY > 0)
					tempAY = 0;
			}
			if (testDirection & 8)
			{
				if (tempVY < 0)
					tempVY = 0;
				if (tempAY < 0)
					tempAY = 0;
			}
			tempX += tempVX*dT;
			tempY += tempVY*dT + tempAY * dT * dT/ 2;
			tempVY += tempAY*dT;
		}

		public function initializeTimeStep():void
		{
			progressText();
			if (isDead)
				return;
			if (hitCooldown != 0)
			{
				hitCooldown--;
				currImage.alpha = 1 - 0.5 * hitCooldown / 30;
			}
			vX = 0;
			if (textFinished)
			{
				if (type == 0)
				{
					isAPressed = false;
					isDPressed = false;
					if (aICounter == 0 || aICounter == 5 || aICounter == 30 || aICounter == 60 || aICounter == 65 || aICounter == 75)
					{
						isSlashing = true;
						slashTimer = 3;
						slashes[slashes.length] = new slashBackwards();
						slashes[slashes.length - 1].x = offsetX+currX;
						slashes[slashes.length - 1].y = offsetY+currY;
						slashes[slashes.length - 1].scaleX = 2;
						slashes[slashes.length - 1].scaleY = 2;
						addChild(slashes[slashes.length - 1]);
						drawSlash();
					}
					if (aICounter == 50)
					{
						attemptJump = true;
						holdJump = true;
					}
					if ((aICounter >= 70 && aICounter < 99) || aICounter == 199)
					{
						isAPressed = true;
					}
					if (aICounter == 99 || (aICounter >= 170 && aICounter < 199))
					{
						isDPressed = true;
					}
					if (aICounter == 100 || aICounter == 105 || aICounter == 130 || aICounter == 160 || aICounter == 165 || aICounter == 175)
					{
						isSlashing = true;
						slashTimer = 3;
						slashes[slashes.length] = new slashForward();
						slashes[slashes.length - 1].x = collisionWidth+offsetX+currX;
						slashes[slashes.length - 1].y = offsetY+currY;
						slashes[slashes.length - 1].scaleX = 2;
						slashes[slashes.length - 1].scaleY = 2;
						addChild(slashes[slashes.length - 1]);
						drawSlash();
					}
					if (aICounter == 50)
					{
						attemptJump = true;
					}
					aICounter++;
					if (aICounter == 200)
						aICounter = 0;
				}
				if (type == 1)
				{
					vY = 0;
					currY = Math.round(currY);
					if (aICounter < 20 && (aICounter % 4 != 0))
						vY = 32;
					if (aICounter < 52 && aICounter > 32 && (aICounter % 4 != 0))
						vY = -32;
					if (aICounter % 4 == 0 && (aICounter <= 20  || aICounter >= 32) && aICounter <= 52)
					{
						isSlashing = true;
						slashTimer = 3;
						slashes[slashes.length] = new slashBackwards();
						slashes[slashes.length - 1].x = offsetX+currX;
						slashes[slashes.length - 1].y = offsetY+currY;
						slashes[slashes.length - 1].scaleX = 2;
						slashes[slashes.length - 1].scaleY = 2;
						addChild(slashes[slashes.length - 1]);
						drawSlash();						
					}
					aICounter++;
					if (aICounter == 64)
						aICounter = 0;
				}
			}
			if (isAPressed)
			{
				vX -= 20;
			}
			if (isDPressed)
			{
				vX += 20;
			}
			for (var i:int = 0; i < slashes.length; i++)
			{
				if (direction == 1)
					slashes[i].x += 25;
				else
					slashes[i].x -= 25;
				if (slashes[i].x < 0 || slashes[i].x > 640)
				{
					removeChild(slashes[i]);
					for (var j:int = i; j+1 < slashes.length; j++ )
					{
						slashes[j] = slashes[j + 1];
					}
					slashes.pop();
				}
			}
			if (slashTimer > 0)
			{
				slashTimer--;
				if (slashTimer == 0)
				{
					isSlashing = false;
					drawCharacter();
				}
			}
			if (jumpTimer > 0 && holdJump)
				vY = -13;
			if (jumpTimer > 0)
				jumpTimer--;
			if (canJump && attemptJump)
			{
				vY = -13;
				jumpTimer = 3;
			}
			canJump = false;
			attemptJump = false;
		}

		public function tick(dT:Number):void
		{
			tempX = currX;
			tempY = currY;
			tempVY = vY;
			tempAY = aY;
			tempVX = vX;
			tempX += tempVX*dT;
			tempY += tempVY*dT + tempAY * dT * dT/ 2;
			tempVY += tempAY * dT;
		}
		
		public function finalizeCollision(testDirection:int):void
		{
			vX = tempVX;
			vY = tempVY;
			aY = tempAY;
			if (testDirection & 2)
				canJump = true;
			if (testDirection & 8)
				jumpTimer = 0;
		}
		
		public function finalizeTick():void
		{
			currX = tempX;
			currY = tempY;
			vX = tempVX;
			vY = tempVY;
			aY = tempAY;
		}
		
		public function updateImagePosition():void
		{
			currImage.x = Math.floor(currX)+offsetX;
			currImage.y = Math.floor(currY)+offsetY;
			if (isAPressed || isDPressed)
			{
				direction = 1;
				if (isAPressed && !isDPressed)
					direction = 0;
			}
			if (direction != drawDirection)
			{
				if (isSlashing)
					drawSlash();
				else
					drawCharacter();
				drawDirection = direction;
			}
		}

		public function Enemy(tGenerator:textdisplayer, nType:int) 
		{
			e1For = new enemy1Forward();
			e1Back = new enemy1Backwards();
			e1ForSlash = new enemy1SlashingForward();
			e1BackSlash = new enemy1SlashingBackwards();
			m1S = new mageS();
			m1C = new mageC();
			isDead = false;
			hp = 0;
			aICounter = 0;
			if (nType == 1)
				aICounter = 4;
			textFinished = false;
			textCounter = 0;
			textLineCounter = 0;
			type = nType;
			tDisplayer = tGenerator;
			isAPressed = false;
			isDPressed = false;
			tempX = 0;
			tempY = 0;
			globalX = 0;
			globalY = 0;
			tempVX = 0;
			tempVY = 0;
			tempAY = 0;
			attemptJump = false;
			holdJump = false;
			jumpTimer = 0;
			canJump = false;
			isSlashing = false;
			haveImage = false;
			slashTimer = 0;
			offsetX = 0;
			offsetY = 0;
			x = 0;
			y = 0;
			currX = 0;
			currY = 0;
			vX = 0;
			vY = 0;
			aY = 0;
			direction = 0;
			drawDirection = 0;
			drawCharacter();
			collisionWidth = currImage.width;
			collisionHeight = currImage.height;
		}
	}
}