package  
{
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.KeyboardEvent;
	import flash.geom.Rectangle;
	
	/**
	 * ...
	 * @author Kragnir
	 */
	public class player extends Sprite
	{
		[Embed(source="../images/characterforward.png")]
		private var characterForward1:Class;
		
		[Embed(source = "../images/characterbackwards.png")]
		private var characterBackwards1:Class;
		
		[Embed(source = "../images/characterslashingforward.png")]
		private var characterSlashingForward1:Class;
		
		[Embed(source = "../images/characterslashingbackwards.png")]
		private var characterSlashingBackwards1:Class;
		
		[Embed(source = "../images/slashforward.png")]
		private var slashForward1:Class;
		
		[Embed(source = "../images/slashbackwards.png")]
		private var slashBackwards1:Class;
			
		private var haveCheckPoint:Boolean;
		private var hitCooldown:int;
		public var direction:int;
		private var drawDirection:int;
		public var checkPointX:Number;
		public var checkPointY:Number;
		public var checkPointGlobalX:int;
		public var checkPointGlobalY:int;
		public var checkPointDir:int;
		public var tempX:Number;
		public var tempY:Number;
		private var tempVX:Number;
		private var tempVY:Number;
		private var tempAY:Number;
		public var offsetX:int;
		public var offsetY:int;
		public var currX:Number;
		public var currY:Number;
		public var collisionWidth:int;
		public var collisionHeight:int;
		public var globalX:Number;
		public var globalY:Number;
		private var vX:Number;
		private var vY:Number;
		private var aY:Number;
		private var isAPressed:Boolean;
		private var isDPressed:Boolean;
		private var attemptJump:Boolean;
		private var holdJump:Boolean;
		private var isSlashing:Boolean;
		private var haveImage:Boolean;
		private var jumpTimer:int;
		private var slashTimer:int;
		private var canJump:Boolean;
		private var canDoubleJump:Boolean;
		private var doubleJumpEnabled:Boolean;
		public var currImage:DisplayObject;
		public var currSlashImage:DisplayObject;
		
		public function powerUp(type:int):void
		{
			if (type == 0)
			{
				doubleJumpEnabled = true;
			}
		}
		
		public function getDamageArea():Vector.<Rectangle>
		{
			var tV:Vector.<Rectangle> = new Vector.<Rectangle>();
			if (isSlashing)
			{
				if (direction == 1)
					tV[tV.length] = new Rectangle(currX+collisionWidth, currY, 10, collisionHeight);
				else
					tV[tV.length] = new Rectangle(currX-offsetX, currY, 10, collisionHeight);
			}
			return tV;
		}
		
		public function checkHit(tV:Vector.<Rectangle>):Boolean
		{
			for (var j:int = 0; j < tV.length; j++)
			{
				var dX:Number = tV[j].x - currX + tV[j].width / 2 - collisionWidth / 2;
				var dY:Number = tV[j].y - currY + tV[j].height / 2 - collisionHeight / 2;
				var RX:Number = tV[j].width / 2 + collisionWidth / 2;
				var RY:Number = tV[j].height / 2 + collisionHeight / 2;
				if (Math.abs(dX) < RX && Math.abs(dY) < RY)
				{
					return true;
				}
			}
			return false;
		}
		
		public function getHit():Boolean
		{
			if (hitCooldown == 0)
			{
				hitCooldown = 30;
				currImage.alpha = 0.5;
				return true;
			}
			return false;
		}
		
		private function drawSlash():void
		{
			if (haveImage)
				removeChild(currImage);
			if (direction == 0)
			{
				offsetX = -10;
				offsetY = 0;
				currImage = new characterSlashingBackwards1();
			}
			else
			{
				offsetX = 0;
				offsetY = 0;
				currImage = new characterSlashingForward1();
			}
			currImage.scaleX = 2;
			currImage.scaleY = 2;
			if (hitCooldown != 0)
				currImage.alpha = 1 - 0.5 * hitCooldown / 30;
			addChild(currImage);
			haveImage = true;
		}
			
		private function drawCharacter():void
		{
			if (haveImage)
				removeChild(currImage);
			if (direction == 0)
			{
				offsetX = 0;
				offsetY = 0;
				currImage = new characterBackwards1();
			}
			else
			{
				offsetX = 0;
				offsetY = 0;
				currImage = new characterForward1();
			}
			currImage.scaleX = 2;
			currImage.scaleY = 2;
			if (hitCooldown != 0)
				currImage.alpha = 1 - 0.5 * hitCooldown / 30;
			addChild(currImage);
			haveImage = true;
		}
		
		public function accelerateY(newAY:Number):void
		{
			aY = newAY;
		}
		
		public function handleKeyboardDown(keyCode:uint):void
		{
			if (keyCode == 32) //Space
			{
				if (slashTimer == 0)
				{
					isSlashing = true;
					slashTimer = 3;
					drawSlash();
				}
			}
			if (keyCode == 65 || keyCode == 37) //A, left
			{
				isAPressed = true;
			}
			if (keyCode == 68 || keyCode == 39) //D, right
			{
				isDPressed = true;
			}
			if (keyCode == 87 || keyCode == 38) //W, up
			{
				attemptJump = true;
				holdJump = true;
			}
		}
		
		public function handleKeyboardUp(keyCode:uint):void
		{
			if (keyCode == 65 || keyCode == 37) //A, left
			{
				isAPressed = false;
			}
			if (keyCode == 68 || keyCode == 39) //D, right
			{
				isDPressed = false;
			}
			if (keyCode == 87 || keyCode == 38) //W, up
			{
				holdJump = false;
			}
		}
		
		public function testCollision(testDirection:int, dT:Number):void
		{
			tempX = currX;
			tempY = currY;
			tempVY = vY;
			tempAY = aY;
			tempVX = vX;
			if (testDirection & 1)
			{
				if (tempVX > 0)
					tempVX = 0;
			}
			if (testDirection & 4)
			{
				if (tempVX < 0)
					tempVX = 0;
			}
			if (testDirection & 2)
			{
				if (tempVY > 0)
					tempVY = 0;
				if (tempAY > 0)
					tempAY = 0;
			}
			if (testDirection & 8)
			{
				if (tempVY < 0)
					tempVY = 0;
				if (tempAY < 0)
					tempAY = 0;
			}
			tempX += tempVX*dT;
			tempY += tempVY*dT + tempAY * dT * dT/ 2;
			tempVY += tempAY*dT;
		}
		
		public function initializeTimeStep():void
		{
			if (hitCooldown != 0)
			{
				hitCooldown--;
				currImage.alpha = 1 - 0.5 * hitCooldown / 30;
			}
			vX = 0;
			if (isAPressed)
			{
				vX -= 8;
			}
			if (isDPressed)
			{
				vX += 8;
			}
			if (slashTimer > 0)
			{
				slashTimer--;
				if (slashTimer == 0)
				{
					isSlashing = false;
					drawCharacter();
				}
			}
			if (canDoubleJump && attemptJump)
			{
				vY = -13;
				jumpTimer = 3;
				canDoubleJump = false;
			}
			if (jumpTimer > 0 && holdJump)
				vY = -13;
			if (jumpTimer > 0)
				jumpTimer--;
			if (canJump && attemptJump)
			{
				vY = -13;
				jumpTimer = 3;
				if (doubleJumpEnabled)
				{
					canDoubleJump = true;
				}
			}
			
			canJump = false;
			attemptJump = false;
		}
		
		public function updateGlobalPos(levelWidth:int, levelHeight:int):Boolean
		{
			var oldGX:int = globalX;
			var oldGY:int = globalY;
			globalX += Math.floor((Math.floor(currX) + offsetX + collisionWidth / 2) / levelWidth);
			globalY += Math.floor((Math.floor(currY) + offsetY + collisionHeight / 2) / levelHeight);
			currX -= levelWidth * Math.floor((Math.floor(currX) + offsetX + collisionWidth / 2) / levelWidth);
			currY -= levelHeight * Math.floor((Math.floor(currY) + offsetY + collisionHeight / 2) / levelHeight);
			if (globalX != oldGX || globalY != oldGY)
				return true;
			return false;
		}
		
		public function tick(dT:Number):void
		{
			tempX = currX;
			tempY = currY;
			tempVY = vY;
			tempAY = aY;
			tempVX = vX;
			tempX += tempVX*dT;
			tempY += tempVY*dT + tempAY * dT * dT/ 2;
			tempVY += tempAY * dT;
		}
		
		public function finalizeCollision(testDirection:int):void
		{
			vX = tempVX;
			vY = tempVY;
			aY = tempAY;
			if (testDirection & 2)
				canJump = true;
			if (testDirection & 8)
				jumpTimer = 0;
		}
		
		public function finalizeTick():void
		{
			currX = tempX;
			currY = tempY;
			vX = tempVX;
			vY = tempVY;
			aY = tempAY;
		}
		
		public function updateImagePosition():void
		{
			x = Math.floor(currX)+offsetX;
			y = Math.floor(currY)+offsetY;
			if (isAPressed || isDPressed)
			{
				direction = 1;
				if (isAPressed && !isDPressed)
					direction = 0;
			}
			if (direction != drawDirection)
			{
				if (isSlashing)
					drawSlash();
				else
					drawCharacter();
				drawDirection = direction;
			}
		}
		
		public function load():void
		{
			doubleJumpEnabled = true;
			tempX = checkPointX;
			tempY = checkPointY;
			globalX = checkPointGlobalX;
			globalY = checkPointGlobalY;
			tempVX = 0;
			tempVY = 0;
			tempAY = 0;
			attemptJump = false;
			holdJump = false;
			jumpTimer = 0;
			canJump = false;
			isSlashing = false;
			haveImage = true;
			slashTimer = 0;
			x = Math.floor(checkPointX);
			y = Math.floor(checkPointY);
			currX = checkPointX;
			currY = checkPointY;
			vX = 0;
			vY = 0;
			aY = 0;
			direction = checkPointDir;
			drawDirection = checkPointDir;
			drawCharacter();
		}
		
		public function save():void
		{
			checkPointX = currX;
			checkPointY = currY;
			checkPointGlobalX = globalX;
			checkPointGlobalY = globalY;
			checkPointDir = direction;
			checkPointDir = drawDirection;
		}
		
		public function player()
		{
			haveCheckPoint = false;
			canDoubleJump = false;
			doubleJumpEnabled = false;
			tempX = 0;
			tempY = 0;
			globalX = 0;
			globalY = 0;
			checkPointX = 0;
			checkPointY = 0;
			checkPointGlobalX = 0;
			checkPointGlobalY = 0;
			checkPointDir = 0;
			tempVX = 0;
			tempVY = 0;
			tempAY = 0;
			isAPressed = false;
			isDPressed = false;
			attemptJump = false;
			holdJump = false;
			jumpTimer = 0;
			canJump = false;
			isSlashing = false;
			haveImage = false;
			slashTimer = 0;
			offsetX = 0;
			offsetY = 0;
			x = 0;
			y = 0;
			currX = 0;
			currY = 0;
			vX = 0;
			vY = 0;
			aY = 0;
			direction = 1;
			drawDirection = 1;
			drawCharacter();
			collisionWidth = currImage.width;
			collisionHeight = currImage.height;
		}
	}
}